<?php
/* 
 * Copyright (C) 2008 Miroslav Jezbera <jezz@hkfree.org>
 * This file is part of LQueues - simple bandwidth manager for linux.
 *
 * LQueues is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LQueues is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with LQueues.  If not, see <http://www.gnu.org/licenses/agpl.html>.
 */

$configFile = 'queues.conf';
$statsUrl = '/queues/queues-stats.pl';
$updateCmd = '/var/www/queues/queues-update.sh';
$reloadCmd = '/var/www/queues/queues-restart.sh';

$allowNonAdmin = true;
$adminPassword = '$6$aSP3/Sca$X5AJvT/oQ0kt86LtpR6Zyc7rS0HkeDqVAVE7BBvYcPP5FDA2g5HIsdV8quzbsE0gjWsr57q6WrPyLfYA6oNNG1';
$maxSpeed = 90112;

$isUpdate = ($_POST and $_POST['id']);
$isDelete = ($_POST and $_POST['delete_id']);
$updateRes = true;
$updateError = '';
if ($isUpdate or $isDelete or !$allowNonAdmin)
	{
	if (!isset($_SERVER['PHP_AUTH_USER']) or $_SERVER['PHP_AUTH_USER'] != 'admin' or crypt($_SERVER['PHP_AUTH_PW'], $adminPassword) != $adminPassword)
		{
		header('WWW-Authenticate: Basic realm="Administrace front"');
		header('HTTP/1.0 401 Unauthorized');
		echo '<html><head><meta http-equiv="content-type" content="text/html; charset=UTF-8"/><title>Přístup zamítnut!</title></head><body><h1>Přístup zamítnut!</h1></body></html>';
		exit;
		}
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<title>Queues</title>
	<link rel="StyleSheet" href="css/main.css" type="text/css" />
	<link rel="StyleSheet" href="css/jquery-ui-1.8.20.custom.css" type="text/css" />
	<script type="text/javascript" src="js/jquery-1.7.1.min.js"></script>
	<script type="text/javascript" src="js/jquery-ui-1.8.20.custom.min.js"></script>
	<script type="text/javascript" src="js/ui.spinner.min.js"></script>
	<script type="text/javascript" src="js/raphael-min.js"></script>
	<script type="text/javascript">
// Global variables
maxSpeed = <?php echo $maxSpeed; ?>;
users = {};
	</script>
	<script type="text/javascript" src="js/scripts.js"></script>
	<script type="text/javascript">
//<![CDATA[
<?php
$devices = array();
$availDevices = array();

function processConfigFile()
	{
	global $configFile;

	$config = fopen($configFile, 'r');
	if (!$config) die(']]></script></head><body><p class="error">Can\'t open config file!</p></body></html>');

	$lineNum = 1;
	while (!feof($config))
		{
		$line = fgets($config);
		if (preg_match('/^\s*(#.*)?$/', $line)) continue;
		if (preg_match('/^\s*%\s*(\b[^=]+\b)\s*=\s*(\b.+\b)\s*$/', $line, $matches))
			{
			processDirective($matches[1], $matches[2]);
			continue;
			}
		$parts = preg_split('/\s*,\s*/', $line);
		addUser($lineNum, ltrim($parts[0]), $parts[1], $parts[2], rtrim($parts[5]));
		$lineNum++;
		}
	listDevices();

	fclose($config);
	}

function addUser($id,$userName,$inIface,$outIface,$ips)
	{
	global $devices;
	if ($inIface != '')
		{
		$devices[$inIface] = 1;
		}
	if ($outIface != '')
		{
		$devices[$outIface] = 1;
		}
	echo "users[$id] = new User($id, \"$userName\",'$inIface','$outIface','$ips'," . crc32("$inIface,$outIface,$ips") . ");\n";
	}

function listDevices()
	{
	global $devices;
	echo 'devices = new Array(' . implode(", ", array_map("quote" ,array_keys($devices))) . ");\n";
	}

function quote($str)
	{
	return "'$str'";
	}

function processDirective($var,$value)
	{
	global $availDevices;
	if ($var == 'devices')
		{
		$parts = preg_split('/\s*,\s*/', $value, -1, PREG_SPLIT_NO_EMPTY);
		foreach ($parts as $value)
			{
			$availDevices[$value] = 1;
			}
		}
	}

function updateConfig($id, $name, $oldName, $inIface, $outIface, $downRate, $upRate, $ips)
	{
	global $updateError, $configFile, $maxSpeed;

	$semid = sem_get(ftok($configFile, 'q'), 1, 0600);
	if ($semid < 0)
		{
		fatalErrorInScript("Can't open semaphore!");
		return false;
		}
	if (!sem_acquire($semid))
		{
		fatalErrorInScript("Can't acquire semaphore!");
		return false;
		}
	if (!copy($configFile, "$configFile.bak"))
		{
		sem_release($semid);
		fatalErrorInScript("Can't backup config file!");
		return false;
		}
	$config = fopen($configFile, 'r+');
	if (!$config)
		{
		sem_release($semid);
		fatalErrorInScript("Can't open config file for writting!");
		return false;
		}
	$lineNum = 0;
	$pos = 0;
	$newline = '';
	# no IP = delete entry
	if (strlen($ips) > 0)
		{
		$newline = "$name,$inIface,$outIface,";
		if ($downRate > 0 and $downRate < $maxSpeed) $newline .= $downRate;
		$newline .= ',';
		if ($upRate > 0 and $upRate < $maxSpeed) $newline .= $upRate;
		$newline .= ",$ips\n";
		}
	if ($id < 0)
		{
		# add new queue
		fseek($config, 0, SEEK_END);
		fwrite($config, "$newline");
		}
	else
		{
		$line = '';
		while (!feof($config) and $lineNum < $id)
			{
			$pos = ftell($config);
			$line = fgets($config);
			if (preg_match('/^\s*([%#].*)?$/', $line)) continue;
			$lineNum++;
			}
		fseek($config, $pos, SEEK_SET);
		if (feof($config) or $lineNum < $id or trim(substr($line,0, strpos($line, ','))) != $oldName)
			{
			sem_release($semid);
			fclose($config);
			$updateError = 'Konfigurační soubor byl změněn (id nebylo nalezeno nebo se neshoduje jméno)!';
			return false;
			}
		$orig = fopen("$configFile.bak", 'r');
		if (!$orig)
			{
			sem_release($semid);
			fclose($config);
			fatalErrorInScript("Can't open backup file!");
			return false;
			}
		fseek($orig, $pos, SEEK_SET);
		fgets($orig); # move after line
		fwrite($config, $newline);
		ftruncate($config, ftell($config));
		while (!feof($orig))
			{
			$line = trim(fgets($orig));
			if ($line != '')
				{
				fwrite($config, "$line\n");
				}
			}
		fclose($orig);
		}
	sem_release($semid);
	fclose($config);
	return true;
	}

function fatalErrorInScript($str)
	{
	echo "//]]></script></head><body>";
	die("<p class=\"error\">$str</p></body>");
	}

# main
echo "statsUrl = '$statsUrl';\n";

if ($isUpdate)
	{
	# Sanitize input
	# Ints
	$id = $_POST['id'];
	$downRate = $_POST['download'];
	$upRate = $_POST['upload'];
	$crc = $_POST['crc'];
	settype($id, "integer");
	settype($downRate, "integer");
	settype($upRate, "integer");
	settype($crc, "integer");

	# Strings
	$inIface = trim($_POST['in_iface']);
	$outIface = trim($_POST['out_iface']);
	$name = trim(preg_replace('/[,;" ]+/', ' ', $_POST['name']));
	$oldName = preg_replace('/[,;"]/', '', $_POST['old_name']);
	$ips = trim(preg_replace('/[^0-9\.\/]+/', ' ', $_POST['ips']));

	if (!preg_match('/^(\w+\d+)?;(\w+\d+)?$/', "$inIface;$outIface"))
		{
		$updateError = "Neplatné rozhraní '$inIface' nebo '$outIface'!";
		$updateRes = false;
		}
	if (!preg_match('/^((([12]\d{2}|\d{1,2})\.){3}([12]\d{2}|\d{1,2})(\/\d{2})? )+$/', "$ips "))
		{
		$updateRes = false;
		$updateError .= "Chyba ve formátu IP adres: $ips!";
		}

	if ($updateRes)
		{
		$updateRes = updateConfig($id, $name, $oldName, $inIface, $outIface, $downRate, $upRate, $ips);
		}
	if ($updateRes)
		{
		# CRC is not for security, but to detect big changes
		if ($id > 0 and crc32("$inIface,$outIface,$ips") == $crc)
			{
			if ($downRate == 0) $downRate = $maxSpeed;
			if ($upRate == 0) $upRate = $maxSpeed;
			if ($inIface)
				{
				system("$updateCmd $id $inIface $downRate");
				}
			if ($outIface)
				{
				system("$updateCmd $id $outIface $upRate");
				}
			}
		else
			{
			system("$reloadCmd");
			}
		}
	}
else if ($isDelete)
	{
	# Sanitize input
	# Ints
	$id = $_POST['id'];
	settype($id, "integer");

	# Strings
	$oldName = preg_replace('/[,;"]/', '', $_POST['old_name']);

	$updateRes = updateConfig($id, '', $oldName, '', '', 0, 0, '');
	if ($updateRes)
		{
		system("$reloadCmd");
		}
	}

processConfigFile();
?>

$(function ()
	{
	fillQueuesList();
	initFilters();
	initLimitsDialog();
	initSettingsPanel();
	setTimer();
	});
//]]>
	</script>
	<style type="text/css">
.filtered .item { display: none }
<?php
function createSelectorForDevice($device, $element)
	{
	return ".filtered.$device $element.item.$device";
	}

function createRowStyles($element, $display)
	{
	global $devices;
	echo implode(
		",\n",
		array_map(
			function ($device) use ($element) { return createSelectorForDevice($device, $element); },
			array_keys($devices))
		) . " { display: $display; }\n";
	}

createRowStyles('tr', 'table-row');
createRowStyles('div', 'block');
?>
	</style>
</head>
<body>
	<h1>Fronty</h1>
<?php
	if ($isUpdate && !$updateRes)
		{
		echo "<p class=\"error\">Aktualizace selhala: $updateError</p>";
		}
?>

	<!-- Settings -->
	<div id="settings">
		<h3>Nastavení</h3>
		<div>
			<h4>Aktualizace</h4>
			<label for="interval">Interval:</label>
			<input type="text" id="interval" class="num" size="3" value="10" />
			<input type="button" id="changeIntervalButton" value="Změnit" />
			<input type="button" id="pauseButton" value="Pozastavit" />
		</div>
		<div id="filters">
			<h4>Filtry</h4>
		</div>
		<input type="button" id="addQueueButton" value="Přidat novou frontu" />
	</div>

	<!-- Graphs -->
	<div id="graphs" class="filtered">
	</div>

	<!-- Queues list -->
	<table id="queues-list" class="filtered">
		<thead>
			<tr class="header"><th>Jméno</th><th>IP</th><th>Max. upload</th><th>Max. download</th><th>Upload</th><th>Download</th></tr>
		</thead>
		<tbody>
		</tbody>
	</table>

	<!-- Limits dialog -->
	<div id="limits-dialog">
		<form method="post">
			<p id="title">&nbsp;</p>
			<a class="close cross">x</a>
			<input type="hidden" id="id" name="id" />
			<input type="hidden" id="old_name" name="old_name" />
			<input type="hidden" id="crc" name="crc" />
			<div class="table">
				<div>
					<label for="name">Jméno:</label> <div><input type="text" name="name" id="name" /></div>
				</div>
				<div>
					<label for="ips">IP:</label> <div><input type="text" id="ips" name="ips" /></div>
				</div>
			</div>
			<div id="rates">
				<div class="table">
					<div>
						<label for="out_iface">Out device:</label>
						<div><select name="out_iface" id="out_iface"></select></div>
					</div>
					<div>
						<label for="upload">Upload: </label>
						<div><input type="text" size="4" id="upload" name="upload" value="0" /> kbit/s</div>
					</div>
				</div>
				<div class="table">
					<div>
						<label for="in_iface">In device:</label>
						<div><select name="in_iface" id="in_iface"></select></div>
					</div>
					<div>
						<label for="download">Download: </label>
						<div><input type="text" size="4" id="download" name="download" value="0" /> kbit/s</div>
					</div>
				</div>
			</div>
			<div class="buttons">
				<input type="button" class="close" value="Zavřít" />
				<input type="submit" value="Změnit" />
				<input type="button" id="delete" name="delete" value="Smazat" />
			</div>
		</form>
		<form id="delete-form" method="post">
			<input type="hidden" id="delete_id" name="id" />
			<input type="hidden" id="delete_old_name" name="old_name" />
		</form>
	</div>
</body>
</html>
