#!/usr/bin/perl -w
# Copyright (C) 2008 Miroslav Jezbera <jezz@hkfree.org>
# This file is part of LQueues - simple bandwidth manager for linux.
#
# LQueues is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# LQueues is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with LQueues.  If not, see <http://www.gnu.org/licenses/agpl.html>.

use strict;
use CGI qw/:param/;

my $tc = '/sbin/tc';

my $device = param('device');
my $counter = param('counter');

open TC, "$tc -s class show dev $device |" or die "Can't execute $tc, because: $!\n";

my $time = time;
my $was_class = 0;

print <<HEADER;
Cache-Control: max-age=1, no-store
Expires: Sat, 14 Jun 2008 20:16:16 GMT
Content-Type: text/xml

<?xml version="1.0"?>
<queues xmlns="http://jezz.hkfree.org">
	<device>$device</device>
	<time>$time</time>
	<counter>$counter</counter>
HEADER

while (<TC>)
	{
	chomp;
	if ($_ =~ /^class (?:htb|hfsc) 1:(\d+) .*\b(?:rate|m2) (\d+)(K?)bit/)
		{
		my ($id, $rate) = ($1, $2);
		my $multiple = 1;
		$multiple = 1000 if ($3 eq 'K');
		$rate = $rate * $multiple / 1024;
		printf("\t<class id=\"%d\">\n\t\t<rate>%.0f</rate>\n", $id, $rate);
		$was_class = 1;
		}
	elsif ($was_class and $_ =~ /^ Sent (\d+) bytes/)
		{
		print "\t\t<bytes>$1</bytes>\n\t</class>\n";
		$was_class = 0;
		}
	}

close TC;

print "</queues>\n";
